-- Test order_campsite_types
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(11);

set search_path to camper, public;

select has_function('camper', 'order_campsite_types', array['uuid[]']);
select function_lang_is('camper', 'order_campsite_types', array['uuid[]'], 'sql');
select function_returns('camper', 'order_campsite_types', array['uuid[]'], 'void');
select isnt_definer('camper', 'order_campsite_types', array['uuid[]']);
select volatility_is('camper', 'order_campsite_types', array['uuid[]'], 'volatile');
select function_privs_are('camper', 'order_campsite_types', array ['uuid[]'], 'guest', array[]::text[]);
select function_privs_are('camper', 'order_campsite_types', array ['uuid[]'], 'employee', array[]::text[]);
select function_privs_are('camper', 'order_campsite_types', array ['uuid[]'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'order_campsite_types', array ['uuid[]'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into campsite_type (company_id, slug, media_id, name, spiel, info, facilities, description, max_campers, bookable_nights, active)
values (1, '87452b88-b48f-48d3-bb6c-0296de64164e', 2, 'A', '', '', '', '', 5, '[1, 7]', true)
     , (1, '9b6370f7-f941-46f2-bc6e-de455675bd0a', 2, 'B', '', '', '', '', 5, '[2, 6]', true)
     , (1, 'b33cfbc9-fbcc-4aac-8335-e5f94ea7e6b2', 2, 'C', '', '', '', '', 5, '[3, 5]', true)
     , (1, '8c4465ec-a690-43d7-854b-7fcd35fccb1c', 2, 'D', '', '', '', '', 5, '[4, 8]', true)
     , (1, 'd28c30fb-57ac-4243-a8c3-ad1a26637f5a', 2, 'E', '', '', '', '', 5, '[5, 9]', true)
;

select lives_ok(
	$$ select order_campsite_types('{b33cfbc9-fbcc-4aac-8335-e5f94ea7e6b2,d28c30fb-57ac-4243-a8c3-ad1a26637f5a,8c4465ec-a690-43d7-854b-7fcd35fccb1c,87452b88-b48f-48d3-bb6c-0296de64164e,9b6370f7-f941-46f2-bc6e-de455675bd0a}') $$,
	'Should be able to sort campsite types using their UUID'
);

select bag_eq(
	$$ select slug::text, position from campsite_type $$,
	$$ values ('b33cfbc9-fbcc-4aac-8335-e5f94ea7e6b2', 1)
	        , ('d28c30fb-57ac-4243-a8c3-ad1a26637f5a', 2)
	        , ('8c4465ec-a690-43d7-854b-7fcd35fccb1c', 3)
	        , ('87452b88-b48f-48d3-bb6c-0296de64164e', 4)
	        , ('9b6370f7-f941-46f2-bc6e-de455675bd0a', 5)
	$$,
	'Should have sorted all campsite types.'
);

select *
from finish();

rollback;
